Hierarchical Menus

You can create Hierarchical Menus with the Menu control also by setting the subItemsPath to a property value that is part of your data source. This sample uses a few Menu controls with hierarchical Menus to demonstrate supported features.

Learn about Input Controls | Hierarchical Menus Documentation | Menu API Reference

import 'bootstrap.css'; import '@mescius/wijmo.styles/wijmo.css'; import './styles.css'; // import * as input from '@mescius/wijmo.input'; import * as wijmo from '@mescius/wijmo'; import { getMenuTree } from './data'; // document.readyState === 'complete' ? init() : window.onload = init; // function init() { let menuTree = getMenuTree(); // // element used to show menu commands let target = document.querySelector('#menuTarget'), targetStyle = target.style, computedStyle = getComputedStyle(target); // // create File menu (uses itemClicked event) let menuFile = new input.Menu('#menu-file', { header: 'File', displayMemberPath: 'header', subItemsPath: 'items', openOnHover: true, isAnimated: true, itemsSource: menuTree.fileMenu, itemClicked: (sender) => { target.innerHTML = `Thank you for clicking <b><i>${sender.text}</i></b>!`; } }); // // create Edit menu (uses itemClicked event) let menuEdit = new input.Menu('#menu-edit', { header: 'Edit', displayMemberPath: 'header', subItemsPath: 'items', openOnHover: true, isAnimated: true, itemsSource: menuTree.editMenu, itemClicked: (sender) => { target.innerHTML = `Thank you for clicking <b><i>${sender.text}</i></b>!`; } }); // // create Format menu (uses command property) let menuFormat = new input.Menu('#menu-format', { header: 'Format', displayMemberPath: 'header', subItemsPath: 'items', openOnHover: true, isAnimated: true, itemsSource: menuTree.formatMenu, command: getFormatMenuCommand() }); // // toggle animations document.querySelector('#isAnimated').addEventListener('click', e => { [menuFile, menuEdit, menuFormat].forEach(menu => { menu.isAnimated = e.target.checked; }); }); // // toggle open on hover document.querySelector('#openOnHover').addEventListener('click', e => { [menuFile, menuEdit, menuFormat].forEach(menu => { menu.openOnHover = e.target.checked; }); }); // // show right-to-left menus document.querySelector('#rtl').addEventListener('click', e => { let menubar = document.querySelector('.menubar'); menubar.setAttribute('dir', e.target.checked ? 'rtl' : 'ltr'); wijmo.Control.refreshAll(menubar); }); // // format menu command function getFormatMenuCommand() { return { executeCommand: (param) => { switch (param.prop) { case 'face': targetStyle.fontFamily = param.header; break; case 'font': switch (param.header) { case 'Bold': targetStyle.fontWeight = targetStyle.fontWeight ? '' : 'bold'; break; case 'Italic': targetStyle.fontStyle = targetStyle.fontStyle ? '' : 'italic'; break; case 'Underline': targetStyle.textDecoration = targetStyle.textDecoration ? '' : 'underline'; break; case 'Larger': targetStyle.fontSize = (parseFloat(computedStyle.fontSize) * 1.2) + 'px'; break; case 'Smaller': targetStyle.fontSize = (parseFloat(computedStyle.fontSize) * .8) + 'px'; break; } break; case 'color': targetStyle.color = param.header.toLowerCase(); break; case 'background': targetStyle.background = param.header.toLowerCase(); break; } }, canExecuteCommand: (param) => { switch (param.prop) { case 'face': return targetStyle.fontFamily != param.header; case 'font': switch (param.header) { case 'Larger': return parseFloat(computedStyle.fontSize) < 24; case 'Smaller': return parseFloat(computedStyle.fontSize) > 8; } break; case 'color': case 'background': let color = param.header.toLowerCase(); return targetStyle.color != color && targetStyle.backgroundColor != color; } return true; } }; } }
<!DOCTYPE html> <html lang="en"> <head> <meta charset="utf-8"> <meta http-equiv="X-UA-Compatible" content="IE=edge"> <title>MESCIUS Wijmo Hierarchical Menus</title> <meta name="viewport" content="width=device-width, initial-scale=1.0"> <!-- SystemJS --> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script> <script src="systemjs.config.js"></script> <script> System.import('./src/app'); </script> </head> <body> <main class="container-fluid"> <div class="menubar"> <div id="menu-file"></div> <div id="menu-edit"></div> <div id="menu-format"></div> </div> <p id="menuTarget"> Wijmo Menus are great! </p> <label> openOnHover <input id="openOnHover" type="checkbox" checked="checked"> </label> <label> isAnimated <input id="isAnimated" type="checkbox" checked="checked"> </label> <label> Right-to-Left <input id="rtl" type="checkbox"> </label> </main> </body> </html>
// export function getMenuTree() { return { fileMenu: [ { header: 'New', items: [ { header: 'Project' }, { header: 'Site' }, { header: 'File' } ] }, { header: 'Open' }, { header: 'Save' }, { header: 'Save As', items: [ { header: 'Normal' }, { header: 'Compressed' }, { header: 'Encrypted' } ] }, { header: '-' }, { header: 'Exit' } ], editMenu: [ { header: 'Go to', items: [ { header: 'Line' }, { header: 'Symbol' }, { header: 'File', items: [ { header: 'Current Project' }, { header: 'Current Solution' }, { header: 'Select...' } ] } ] }, { header: 'Find and Replace', items: [ { header: 'Quick Find' }, { header: 'Quick Replace' }, { header: 'Find in Files' }, { header: 'Replace in Files', items: [ { header: 'All' }, { header: 'Read/Write Only' } ] } ] }, { header: '-' }, { header: 'Undo' }, { header: 'Redo' } ], formatMenu: [ { header: 'Font', items: [ { header: 'Family', items: [ { header: 'Arial', prop: 'face' }, { header: 'Times', prop: 'face' }, { header: 'Courier', prop: 'face' }, { header: 'Verdana', prop: 'face' }, { header: 'Georgia', prop: 'face' } ] }, { header: 'Bold', prop: 'font' }, { header: 'Italic', prop: 'font' }, { header: 'Underline', prop: 'font' }, { header: '-' }, { header: 'Larger', prop: 'font' }, { header: 'Smaller', prop: 'font' } ] }, { header: 'Color', items: [ { header: 'Black', prop: 'color' }, { header: 'Red', prop: 'color' }, { header: 'Green', prop: 'color' }, { header: 'Blue', prop: 'color' } ] }, { header: 'Background', items: [ { header: 'White', prop: 'background' }, { header: 'Red', prop: 'background' }, { header: 'Green', prop: 'background' }, { header: 'Blue', prop: 'background' } ] } ] }; }
label { margin-bottom: 15px; margin-right: 25px; } /* element affected by the menu commands */ #menuTarget { font-size: 18pt; text-align: center; padding: 16px; margin: 6px 0; background: #00c1d5; color: black; border: 1px solid rgba(0, 0, 0, .25); } /* bar containing the menus */ .menubar { position: sticky; display: flex; background: #fddfa7; padding: 12px; top: 0; } /* customize wijmo default styles */ .wj-state-selected { color: black; background: orange; } .wj-menu { padding: 6px 14px; border: none; background: transparent; } .wj-menu:hover, .wj-menu.wj-state-focused { background: rgba(0, 0, 0, .05); } .wj-menu .wj-input-group .wj-input-group-btn { /* hide the menu's drop-down buttons */ display: none; } .wj-listbox.wj-menu-items { min-width: 8em; border: none; background: #fddfa7; } .wj-listbox.wj-menu-items .wj-listbox-item:not(.wj-separator) { padding: 6px 12px; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, }, meta: { '*.css': { loader: 'css' }, }, paths: { // paths serve as alias 'npm:': 'node_modules/', 'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/', 'pcdn:': 'https://cdn.jsdelivr.net/npm/' }, // map tells the System loader where to look for things map: { '@mescius/wijmo': 'cdn:@mescius/wijmo/index.js', '@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js', '@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles', '@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures', '@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js', '@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js', '@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js', '@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js', '@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js', '@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js', '@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js', '@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js', '@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js', '@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js', '@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js', '@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js', '@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js', '@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js', '@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js', '@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js', '@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js', '@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js', '@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js', '@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js', '@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js', '@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js', '@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js', '@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js', '@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js', '@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js', '@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js', '@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js', '@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js', '@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js', '@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js', '@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js', '@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js', '@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js', '@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js', '@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js', '@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js', '@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js', '@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js', '@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js', '@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js', '@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js', '@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js', jszip: 'pcdn:jszip@3.8.0/dist/jszip.js', 'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css', css: 'pcdn:systemjs-plugin-css@0.1.37/css.js', 'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'js', }, node_modules: { defaultExtension: 'js', }, }, }); })(this);

<template>
<div class="container-fluid">
<div class="menubar">
<wj-menu id="fileMenu" :header="'File'" :displayMemberPath="'header'" :subItemsPath="'items'"
:showDropDownButton="false" :openOnHover="openOnHover" :isAnimated="isAnimated"
:itemsSource="menuTree.fileMenu" :itemClicked="menuItemClicked" :initialized="initMenu"></wj-menu>
<wj-menu id="editMenu" :header="'Edit'" :displayMemberPath="'header'" :subItemsPath="'items'"
:showDropDownButton="false" :openOnHover="openOnHover" :isAnimated="isAnimated"
:itemsSource="menuTree.editMenu" :itemClicked="menuItemClicked" :initialized="initMenu"></wj-menu>
<wj-menu id="formatMenu" :header="'Format'" :displayMemberPath="'header'" :subItemsPath="'items'"
:showDropDownButton="false" :openOnHover="openOnHover" :isAnimated="isAnimated"
:itemsSource="menuTree.formatMenu" :initialized="initMenu">
</wj-menu>
</div>
<p id="menuTarget" ref="menuTarget">
Wijmo Menus are great!
</p>
<label>
openOnHover
<input type="checkbox" v-model="openOnHover">
</label>
<label>
isAnimated
<input type="checkbox" v-model="isAnimated">
</label>
<label>
Right-to-Left
<input type="checkbox" @change="rtlChanged">
</label>
</div>
</template>
<script setup>
import { getMenuTree } from "./data";
import { ref, onMounted } from "vue";
const menuTree = ref(getMenuTree());
const isAnimated = ref(true);
const editMenu = ref(null);
const fileMenu = ref(null);
const openOnHover = ref(true);
const formatMenu = ref(null);
const menuTarget = ref();
onMounted(function () {
formatMenu.value.command = formatMenuCommand();
});
function initMenu(menu) {
switch (menu.hostElement.id) {
case 'fileMenu':
fileMenu.value = menu;
break;
case 'editMenu':
editMenu.value = menu;
break;
case 'formatMenu':
formatMenu.value = menu;
break;
}
}
function menuItemClicked(menu) {
menuTarget.value.innerHTML = `Thank you for clicking <b><i>${menu.text}</i></b>!`;
}
function formatMenuCommand(param) {
return {
executeCommand: function (param) {
let ts = menuTarget.value.style;
let cssStyle = window.getComputedStyle(menuTarget.value, null);
switch (param.prop) {
case "face":
ts.fontFamily = param.header;
break;
case "font":
switch (param.header) {
case "Bold":
ts.fontWeight = ts.fontWeight ? "" : "bold";
break;
case "Italic":
ts.fontStyle = ts.fontStyle ? "" : "italic";
break;
case "Underline":
ts.textDecoration = ts.textDecoration ? "" : "underline";
break;
case "Larger":
ts.fontSize = parseFloat(cssStyle.fontSize) * 1.2 + "px";
break;
case "Smaller":
ts.fontSize = parseFloat(cssStyle.fontSize) * 0.8 + "px";
break;
}
break;
case "color":
ts.color = param.header.toLowerCase();
break;
case "background":
ts.background = param.header.toLowerCase();
break;
}
},
canExecuteCommand: function (param) {
let ts = menuTarget.value.style;
let cssStyle = window.getComputedStyle(menuTarget.value, null);
switch (param.prop) {
case "face":
return ts.fontFamily != param.header;
case "font":
switch (param.header) {
case "Larger":
return parseFloat(cssStyle.fontSize) < 24;
case "Smaller":
return parseFloat(cssStyle.fontSize) > 8;
}
break;
case "color":
case "background":
let color = param.header.toLowerCase();
return ts.color != color && ts.backgroundColor != color;
}
return true;
},
};
}
function rtlChanged(e) {
let menubar = document.querySelector(".menubar");
menubar.setAttribute("dir", e.target.checked ? "rtl" : "ltr");
wijmo.Control.refreshAll(menubar);
}
</script>
<style>
label {
margin-bottom: 15px;
margin-right: 25px;
}
/* element affected by the menu commands */
#menuTarget {
font-size: 18pt;
text-align: center;
padding: 16px;
margin: 6px 0;
background: #00c1d5;
color: black;
border: 1px solid rgba(0, 0, 0, .25);
}
/* bar containing the menus */
.menubar {
position: sticky;
display: flex;
background: #fddfa7;
padding: 12px;
top: 0;
}
/* customize wijmo default styles */
.wj-state-selected {
color: black;
background: orange;
}
.container-fluid .wj-menu {
padding: 6px 14px;
border: none;
background: transparent;
}
.container-fluid .wj-menu:hover,
.container-fluid .wj-menu.wj-state-focused {
background: rgba(0, 0, 0, .05);
}
.container-fluid .wj-menu .wj-input-group .wj-input-group-btn {
/* hide the menu's drop-down buttons */
display: none;
}
.wj-listbox.wj-menu-items {
min-width: 8em;
border: none;
background: #fddfa7;
}
.wj-listbox.wj-menu-items .wj-listbox-item:not(.wj-separator) {
padding: 6px 12px;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Hierarchical Menus</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
//
export function getMenuTree() {
return {
fileMenu: [
{
header: 'New',
items: [
{
header: 'Project'
},
{
header: 'Site'
},
{
header: 'File'
}
]
},
{
header: 'Open'
},
{
header: 'Save'
},
{
header: 'Save As',
items: [
{
header: 'Normal'
},
{
header: 'Compressed'
},
{
header: 'Encrypted'
}
]
},
{
header: '-'
},
{
header: 'Exit'
}
],
editMenu: [
{
header: 'Go to',
items: [
{
header: 'Line'
},
{
header: 'Symbol'
},
{
header: 'File',
items: [
{
header: 'Current Project'
},
{
header: 'Current Solution'
},
{
header: 'Select...'
}
]
}
]
},
{
header: 'Find and Replace',
items: [
{
header: 'Quick Find'
},
{
header: 'Quick Replace'
},
{
header: 'Find in Files'
},
{
header: 'Replace in Files',
items: [
{
header: 'All'
},
{
header: 'Read/Write Only'
}
]
}
]
},
{
header: '-'
},
{
header: 'Undo'
},
{
header: 'Redo'
}
],
formatMenu: [
{
header: 'Font',
items: [
{
header: 'Family',
items: [
{
header: 'Arial',
prop: 'face'
},
{
header: 'Times',
prop: 'face'
},
{
header: 'Courier',
prop: 'face'
},
{
header: 'Verdana',
prop: 'face'
},
{
header: 'Georgia',
prop: 'face'
}
]
},
{
header: 'Bold',
prop: 'font'
},
{
header: 'Italic',
prop: 'font'
},
{
header: 'Underline',
prop: 'font'
},
{
header: '-'
},
{
header: 'Larger',
prop: 'font'
},
{
header: 'Smaller',
prop: 'font'
}
]
},
{
header: 'Color',
items: [
{
header: 'Black',
prop: 'color'
},
{
header: 'Red',
prop: 'color'
},
{
header: 'Green',
prop: 'color'
},
{
header: 'Blue',
prop: 'color'
}
]
},
{
header: 'Background',
items: [
{
header: 'White',
prop: 'background'
},
{
header: 'Red',
prop: 'background'
},
{
header: 'Green',
prop: 'background'
},
{
header: 'Blue',
prop: 'background'
}
]
}
]
};
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useRef, useState } from 'react';
import useEvent from 'react-use-event-hook';
import { Control } from '@mescius/wijmo';
import { Menu } from '@mescius/wijmo.react.input';
import './app.css';
import { menuTree } from './data';
function App() {
const [isAnimated, setIsAnimated] = useState(true);
const [openOnHover, setOpenOnHover] = useState(true);
const menuTargetRef = useRef(null);
const initFormatMenu = useEvent((sender) => {
sender.command = {
executeCommand: (param) => {
if (menuTargetRef.current) {
let ts = menuTargetRef.current.style;
let cssStyle = getComputedStyle(menuTargetRef.current, null);
switch (param.prop) {
case 'face':
ts.fontFamily = param.header;
break;
case 'font':
switch (param.header) {
case 'Bold':
ts.fontWeight = ts.fontWeight ? '' : 'bold';
break;
case 'Italic':
ts.fontStyle = ts.fontStyle ? '' : 'italic';
break;
case 'Underline':
ts.textDecoration = ts.textDecoration ? '' : 'underline';
break;
case 'Larger':
ts.fontSize = (parseFloat(cssStyle.fontSize) * 1.2) + 'px';
break;
case 'Smaller':
ts.fontSize = (parseFloat(cssStyle.fontSize) * .8) + 'px';
break;
}
break;
case 'color':
ts.color = param.header.toLowerCase();
break;
case 'background':
ts.background = param.header.toLowerCase();
break;
}
}
},
canExecuteCommand: (param) => {
if (menuTargetRef.current) {
let ts = menuTargetRef.current.style;
let cssStyle = getComputedStyle(menuTargetRef.current, null);
switch (param.prop) {
case 'face':
return ts.fontFamily != param.header;
case 'font':
switch (param.header) {
case 'Larger':
return parseFloat(cssStyle.fontSize) < 24;
case 'Smaller':
return parseFloat(cssStyle.fontSize) > 8;
}
break;
case 'color':
case 'background':
let color = param.header.toLowerCase();
return ts.color != color && ts.backgroundColor != color;
}
}
return true;
}
};
});
const menuItemClicked = useEvent((sender) => {
if (menuTargetRef.current) {
menuTargetRef.current.innerHTML = `Thank you for clicking <b><i>${sender.text}</i></b>!`;
}
});
const changeOpenOnHover = useEvent((value) => {
setOpenOnHover(value);
});
const changeAnimation = useEvent((value) => {
setIsAnimated(value);
});
const changeRtl = useEvent((value) => {
let menubar = document.querySelector('.menubar');
menubar.setAttribute('dir', value ? 'rtl' : 'ltr');
Control.refreshAll(menubar);
});
return (<main className="container-fluid">
<div className="menubar">
<Menu id="fileMenu" header="File" displayMemberPath="header" subItemsPath="items" showDropDownButton={false} openOnHover={openOnHover} isAnimated={isAnimated} itemsSource={menuTree.fileMenu} itemClicked={menuItemClicked}/>
<Menu id="editMenu" header="Edit" displayMemberPath="header" subItemsPath="items" showDropDownButton={false} openOnHover={openOnHover} isAnimated={isAnimated} itemsSource={menuTree.editMenu} itemClicked={menuItemClicked}/>
<Menu id="formatMenu" header="Format" displayMemberPath="header" subItemsPath="items" openOnHover={openOnHover} isAnimated={isAnimated} itemsSource={menuTree.formatMenu} initialized={initFormatMenu}/>
</div>
<p id="menuTarget" ref={menuTargetRef}>
Wijmo Menus are great!
</p>
<label>
openOnHover
<input type="checkbox" defaultChecked={openOnHover} onChange={e => { changeOpenOnHover(e.target.checked); }}/>
</label>
<label>
isAnimated
<input type="checkbox" defaultChecked={isAnimated} onChange={e => { changeAnimation(e.target.checked); }}/>
</label>
<label>
Right-to-Left
<input type="checkbox" defaultChecked={false} onChange={e => { changeRtl(e.target.checked); }}/>
</label>
</main>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Hierarchical Menus</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
label {
margin-bottom: 15px;
margin-right: 25px;
}
/* element affected by the menu commands */
#menuTarget {
font-size: 18pt;
text-align: center;
padding: 16px;
margin: 6px 0;
background: #00c1d5;
color: black;
border: 1px solid rgba(0, 0, 0, .25);
}
/* bar containing the menus */
.menubar {
position: sticky;
display: flex;
background: #fddfa7;
padding: 12px;
top: 0;
}
/* customize wijmo default styles */
.wj-state-selected {
color: black;
background: orange;
}
.wj-menu {
padding: 6px 14px;
border: none;
background: transparent;
}
.wj-menu:hover,
.wj-menu.wj-state-focused {
background: rgba(0, 0, 0, .05);
}
.wj-menu .wj-input-group .wj-input-group-btn {
/* hide the menu's drop-down buttons */
display: none;
}
.wj-listbox.wj-menu-items {
min-width: 8em;
border: none;
background: #fddfa7;
}
.wj-listbox.wj-menu-items .wj-listbox-item:not(.wj-separator) {
padding: 6px 12px;
}
function getMenuTree() {
return {
fileMenu: [
{
header: 'New',
items: [
{
header: 'Project'
},
{
header: 'Site'
},
{
header: 'File'
}
]
},
{
header: 'Open'
},
{
header: 'Save'
},
{
header: 'Save As',
items: [
{
header: 'Normal'
},
{
header: 'Compressed'
},
{
header: 'Encrypted'
}
]
},
{
header: '-'
},
{
header: 'Exit'
}
],
editMenu: [
{
header: 'Go to',
items: [
{
header: 'Line'
},
{
header: 'Symbol'
},
{
header: 'File',
items: [
{
header: 'Current Project'
},
{
header: 'Current Solution'
},
{
header: 'Select...'
}
]
}
]
},
{
header: 'Find and Replace',
items: [
{
header: 'Quick Find'
},
{
header: 'Quick Replace'
},
{
header: 'Find in Files'
},
{
header: 'Replace in Files',
items: [
{
header: 'All'
},
{
header: 'Read/Write Only'
}
]
}
]
},
{
header: '-'
},
{
header: 'Undo'
},
{
header: 'Redo'
}
],
formatMenu: [
{
header: 'Font',
items: [
{
header: 'Family',
items: [
{
header: 'Arial',
prop: 'face'
},
{
header: 'Times',
prop: 'face'
},
{
header: 'Courier',
prop: 'face'
},
{
header: 'Verdana',
prop: 'face'
},
{
header: 'Georgia',
prop: 'face'
}
]
},
{
header: 'Bold',
prop: 'font'
},
{
header: 'Italic',
prop: 'font'
},
{
header: 'Underline',
prop: 'font'
},
{
header: '-'
},
{
header: 'Larger',
prop: 'font'
},
{
header: 'Smaller',
prop: 'font'
}
]
},
{
header: 'Color',
items: [
{
header: 'Black',
prop: 'color'
},
{
header: 'Red',
prop: 'color'
},
{
header: 'Green',
prop: 'color'
},
{
header: 'Blue',
prop: 'color'
}
]
},
{
header: 'Background',
items: [
{
header: 'White',
prop: 'background'
},
{
header: 'Red',
prop: 'background'
},
{
header: 'Green',
prop: 'background'
},
{
header: 'Blue',
prop: 'background'
}
]
}
]
};
}
export const menuTree = getMenuTree();
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import * as wijmo from '@mescius/wijmo';
import * as input from '@mescius/wijmo.input';
//
import '@angular/compiler';
import {
Component,
enableProdMode,
ElementRef,
Inject,
ViewChild,
OnInit,
ɵresolveComponentResources,
} from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { WjInputModule } from '@mescius/wijmo.angular2.input';
import { DataService, TMenuTree, TMenuItem } from './app.data';
//
@Component({
standalone: true,
providers: [DataService],
imports: [WjInputModule, FormsModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent implements OnInit {
@ViewChild('menuTarget', { static: true }) private _menuTarget: ElementRef; // element used to show menu commands
@ViewChild('fileMenu', { static: true }) private _fileMenu: input.Menu;
@ViewChild('editMenu', { static: true }) private _editMenu: input.Menu;
@ViewChild('formatMenu', { static: true }) private _formatMenu: input.Menu;
private _rtl = false;
//
menuTree: TMenuTree;
isAnimated = true;
openOnHover = true;
//
constructor(@Inject(DataService) private dataService: DataService) {
this.menuTree = dataService.getMenuTree();
}
//
get rtl(): boolean {
return this._rtl;
}
set rtl(value: boolean) {
let menubar = <HTMLElement>document.querySelector('.menubar');
menubar.setAttribute('dir', (this._rtl = value) ? 'rtl' : 'ltr');
wijmo.Control.refreshAll(menubar);
}
//
ngOnInit() {
this._fileMenu.itemClicked.addHandler(this.menuItemClicked.bind(this));
this._editMenu.itemClicked.addHandler(this.menuItemClicked.bind(this));
this._formatMenu.command = this.formatMenuCommand;
}
//
menuItemClicked(menu: input.Menu) {
this._menuTarget.nativeElement.innerHTML = `Thank you for clicking <b><i>${menu.text}</i></b>!`;
}
//
formatMenuCommand = {
executeCommand: (param: TMenuItem) => {
let ts = this._menuTarget.nativeElement.style;
let cs = getComputedStyle(this._menuTarget.nativeElement);
//
switch (param.prop) {
case 'face':
ts.fontFamily = param.header;
break;
case 'font':
switch (param.header) {
case 'Bold':
ts.fontWeight = ts.fontWeight ? '' : 'bold';
break;
case 'Italic':
ts.fontStyle = ts.fontStyle ? '' : 'italic';
break;
case 'Underline':
ts.textDecoration = ts.textDecoration ? '' : 'underline';
break;
case 'Larger':
ts.fontSize = parseFloat(cs.fontSize) * 1.2 + 'px';
break;
case 'Smaller':
ts.fontSize = parseFloat(cs.fontSize) * 0.8 + 'px';
break;
}
break;
case 'color':
ts.color = param.header.toLowerCase();
break;
case 'background':
ts.background = param.header.toLowerCase();
break;
}
},
canExecuteCommand: (param: TMenuItem) => {
let ts = this._menuTarget.nativeElement.style;
let cs = getComputedStyle(this._menuTarget.nativeElement);
//
switch (param.prop) {
case 'face':
return ts.fontFamily != param.header;
case 'font':
switch (param.header) {
case 'Larger':
return parseFloat(cs.fontSize) < 24;
case 'Smaller':
return parseFloat(cs.fontSize) > 8;
}
break;
case 'color':
case 'background':
let color = param.header.toLowerCase();
return ts.color != color && ts.backgroundColor != color;
}
return true;
},
};
}
//
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Hierarchical Menus</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<main class="container-fluid">
<div class="menubar">
<wj-menu #fileMenu [header]="'File'" [displayMemberPath]="'header'" [subItemsPath]="'items'"
[openOnHover]="openOnHover" [isAnimated]="isAnimated" [itemsSource]="menuTree.fileMenu">
</wj-menu>
<wj-menu #editMenu [header]="'Edit'" [displayMemberPath]="'header'" [subItemsPath]="'items'"
[openOnHover]="openOnHover" [isAnimated]="isAnimated" [itemsSource]="menuTree.editMenu">
</wj-menu>
<wj-menu #formatMenu [header]="'Format'" [displayMemberPath]="'header'" [subItemsPath]="'items'"
[openOnHover]="openOnHover" [isAnimated]="isAnimated" [itemsSource]="menuTree.formatMenu">
</wj-menu>
</div>
<p #menuTarget id="menuTarget">
Wijmo Menus are great!
</p>
<label>
openOnHover
<input type="checkbox" [(ngModel)]="openOnHover">
</label>
<label>
isAnimated
<input type="checkbox" [(ngModel)]="isAnimated">
</label>
<label>
Right-to-Left
<input type="checkbox" [(ngModel)]="rtl">
</label>
</main>
import { Injectable } from '@angular/core';
//
export type TMenuItem = {
header: string;
prop?: string;
items?: TMenuItem[]
}
//
export type TMenuTree = {
[key: string]: TMenuItem[]
}
//
@Injectable()
export class DataService {
getMenuTree() {
return <TMenuTree>{
fileMenu: [
{
header: 'New',
items: [
{
header: 'Project'
},
{
header: 'Site'
},
{
header: 'File'
}
]
},
{
header: 'Open'
},
{
header: 'Save'
},
{
header: 'Save As',
items: [
{
header: 'Normal'
},
{
header: 'Compressed'
},
{
header: 'Encrypted'
}
]
},
{
header: '-'
},
{
header: 'Exit'
}
],
editMenu: [
{
header: 'Go to',
items: [
{
header: 'Line'
},
{
header: 'Symbol'
},
{
header: 'File',
items: [
{
header: 'Current Project'
},
{
header: 'Current Solution'
},
{
header: 'Select...'
}
]
}
]
},
{
header: 'Find and Replace',
items: [
{
header: 'Quick Find'
},
{
header: 'Quick Replace'
},
{
header: 'Find in Files'
},
{
header: 'Replace in Files',
items: [
{
header: 'All'
},
{
header: 'Read/Write Only'
}
]
}
]
},
{
header: '-'
},
{
header: 'Undo'
},
{
header: 'Redo'
}
],
formatMenu: [
{
header: 'Font',
items: [
{
header: 'Family',
items: [
{
header: 'Arial',
prop: 'face'
},
{
header: 'Times',
prop: 'face'
},
{
header: 'Courier',
prop: 'face'
},
{
header: 'Verdana',
prop: 'face'
},
{
header: 'Georgia',
prop: 'face'
}
]
},
{
header: 'Bold',
prop: 'font'
},
{
header: 'Italic',
prop: 'font'
},
{
header: 'Underline',
prop: 'font'
},
{
header: '-'
},
{
header: 'Larger',
prop: 'font'
},
{
header: 'Smaller',
prop: 'font'
}
]
},
{
header: 'Color',
items: [
{
header: 'Black',
prop: 'color'
},
{
header: 'Red',
prop: 'color'
},
{
header: 'Green',
prop: 'color'
},
{
header: 'Blue',
prop: 'color'
}
]
},
{
header: 'Background',
items: [
{
header: 'White',
prop: 'background'
},
{
header: 'Red',
prop: 'background'
},
{
header: 'Green',
prop: 'background'
},
{
header: 'Blue',
prop: 'background'
}
]
}
]
};
}
}
label {
margin-bottom: 15px;
margin-right: 25px;
}
/* element affected by the menu commands */
#menuTarget {
font-size: 18pt;
text-align: center;
padding: 16px;
margin: 6px 0;
background: #00c1d5;
color: black;
border: 1px solid rgba(0, 0, 0, .25);
}
/* bar containing the menus */
.menubar {
position: sticky;
display: flex;
background: #fddfa7;
padding: 12px;
top: 0;
}
/* customize wijmo default styles */
.wj-state-selected {
color: black;
background: orange;
}
.wj-menu {
padding: 6px 14px;
border: none;
background: transparent;
}
.wj-menu:hover,
.wj-menu.wj-state-focused {
background: rgba(0, 0, 0, .05);
}
.wj-menu .wj-input-group .wj-input-group-btn {
/* hide the menu's drop-down buttons */
display: none;
}
.wj-listbox.wj-menu-items {
min-width: 8em;
border: none;
background: #fddfa7;
}
.wj-listbox.wj-menu-items .wj-listbox-item:not(.wj-separator) {
padding: 6px 12px;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/di': 'npm:@angular/core/fesm2022/primitives/di.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);